#include "include/object.h"
#include <tonc.h>

void Object_Init(Object *obj,int x,int y,int dir){
  obj->x = x << 8; obj->y = y << 8;
  obj->stepX = 0; obj->stepY = 0;
  obj->moveX = 0; obj->stepY = 0;
  obj->maxiX = 0x00BEBC20; obj->maxiY = 0x00BEBC20;
  obj->direction = dir;
  obj->keyL = 0;
  obj->keyR = 0;
  obj->keyU = 0;
  obj->keyD = 0;
}

void direction_set(Object *obj){
  int keyL = obj->keyL;
  int keyR = obj->keyR;
  int keyU = obj->keyU;
  int keyD = obj->keyD;
  int dir = obj->direction;
  if ((keyL || keyR) && (keyU || keyD)){
    if (keyU && dir == 270)
      obj->direction = 90;
    else if (keyD && dir == 90)
      obj->direction = 270;
    else if (keyL && dir == 0)
      obj->direction = 180;
    else if (keyR && dir == 180)
      obj->direction = 0;
  }
  else if (keyU) 
    obj->direction = 90;
  else if (keyD)
    obj->direction = 270;
  else if (keyL)
    obj->direction = 180;
  else if (keyR)
    obj->direction = 0;
}

void movement_norm(Object *obj){
  int absvY;
  int absvX;
  int moveF;
  int loopC;
  obj->moveY = (obj->keyD - obj->keyU) * obj->maxiY;
  obj->moveX = (obj->keyR - obj->keyL) * obj->maxiX;
  absvY = ABS(obj->moveY);
  absvX = ABS(obj->moveX);
  if (absvY || absvX){
    if (absvY && absvX){
      moveF = MOVE_DIAGONAL;
      if (absvY == obj->maxiY && absvX == obj->maxiX)
        obj->stepY = obj->stepX;
    }
    else
      moveF = MOVE_LINEAR;
    if (absvY){
      loopC = 0;
      obj->stepY += absvY;
      while (obj->stepY >= MOVE_LINEAR){
        loopC += 0x100;
        obj->stepY -= moveF;
      }
      if (loopC)
	    obj->y += loopC * SGN(obj->moveY);
    }
    if (absvX){
      loopC = 0;
      obj->stepX += absvX;
      while (obj->stepX >= MOVE_LINEAR){
        loopC += 0x0100;
        obj->stepX -= moveF;
      }
      if (loopC)
        obj->x += loopC * SGN(obj->moveX);
    }
  }
  else{
    obj->stepY = 0;
    obj->stepX = 0;
  }
}